latex input:	mmd-tufte-handout-header
Title:	MultiMarkdown User's Guide
Author:	Fletcher T. Penney
Version:	{{version.txt}}
Revised:	2015-03-09  
Keywords:	MultiMarkdown, Markdown, LaTeX, PDF, RTF, LyX, HTML
Base Header Level:	2
CSS:	{{css.txt}}
MMD Footer:	links.txt
latex mode:	memoir
latex input:	mmd-tufte-handout-begin-doc
latex footer:	mmd-tufte-footer


#  [%title] #

> MultiMarkdown Version [%version]  
> Last Revised [%revised]

You can view the MultiMarkdown User's Guide as a **single document**:

* [HTML](MMD_Users_Guide.html)
* [PDF](MMD_Users_Guide.pdf)
* [OpenDocument](MMD_Users_Guide.fodt)

Or as a set of web pages for individual sections:

* [Introduction](introduction.html)
* [Philosophy](philosophy.html)
* [Installation](installation.html)
* [Using MultiMarkdown](using_mmd.html)
* [MultiMarkdown Syntax](syntax.html)
	* [Metadata](metadata.html)
	* [Smart Typography](typography.html)
	* [Cross-References](cross-references.html)
	* [Link and Image Attributes](attributes.html)
	* [Images](images.html)
	* [Tables](tables.html)
	* [Footnotes](footnotes.html)
	* [Citations](citations.html)
	* [Definition Lists](definitionlists.html)
	* [Abbreviations](abbreviations.html)
	* [Fenced Code Blocks](fences.html)
	* [Math](math.html)
	* [Glossaries](glossary.html)
	* [CriticMarkup](criticmarkup.html)
	* [Raw Source](raw.html)
	* [File Transclusion](transclusion.html)
	* [Escaped Newlines](escaped-newlines.html)
* ["Hacking" MultiMarkdown](hacking.html)
* [Known Issues](known_issues.html)
* [To Do](to_do.html)
* [More Information](more_information.html)
* [Acknowledgements](acknowledgements.html)
* [Release Notes](release_notes.html)
